berou/accounts/urls.py
from django.conf import settings
from django.conf.urls import url

from accounts import views

urlpatterns = [
    url(r'^$', views.RegisterUserView.as_view(), name='register_user'),
    url(r'^login/$',
        views.LoginUserView.as_view(),
        name='login_user'),
    url(r'^logout/$', 'django.contrib.auth.views.logout',
        {'next_page': settings.LOGOUT_REDIRECT_URL},
        name='logout_user'),
    url(r'^profile/(?P<pk>\d+)$',
        views.ProfileView.as_view(),
        name='profile'),
    url(r'^edit_profile/(?P<pk>\d+)$',
        views.EditProfileView.as_view(),
        name='edit_profile'),
    url(r'^change_password/$',
        views.ChangePasswordView.as_view(),
        name='change_password'),
]

berou/application_system/urls.py
# -*- coding: utf-8 -*-

from django.conf.urls import url

from application_system import views

urlpatterns = [
    url(r'^$', views.ListAppView.as_view(), name='list_app'),
    url(r'^manage_my_apps/$',
        views.ListAvailableAppView.as_view(),
        name='manage_my_apps'),
    url(r'^install_app/$', views.InstallAppView.as_view(), name='install_app'),
    url(r'^uninstall_app/(?P<package>[\w-]+)/$',
        views.UninstallAppView.as_view(),
        name='uninstall_app'),
    url(r'activate_app/(?P<package>[\w-]+)/$',
        views.ActivateAppView.as_view(),
        name='activate_app'),
    url(r'disable_app/(?P<package>[\w-]+)/$',
        views.DisableAppView.as_view(),
        name='disable_app'),
]

berou/berou/urls.py
# -*- coding: utf-8 -*-

import importlib
import logging

from django.conf import settings
from django.conf.urls import include, url
from django.conf.urls.static import static
from django.contrib import admin

from accounts import urls as accounts_urls
from berou import berou_urls
from application_system import urls as application_system_urls
from application_system import models

logger = logging.getLogger('berou')


def get_plugin_packages():
    return [app.package for app in models.App.objects.all()]


urlpatterns = [
    # Examples:
    # url(r'^$', 'berou.views.home', name='home'),
    # url(r'^blog/', include('blog.urls')),

    url(r'^admin/', include(admin.site.urls)),
    url(r'^accounts/', include(accounts_urls, namespace='accounts')),
    url(r'^application_system/', include(application_system_urls,
                                         namespace='application_system')),
    url(r'^', include(berou_urls, namespace='berou')),

]

for plugin in get_plugin_packages():
    plugin_package = importlib.import_module(plugin)

    try:
        urls = importlib.import_module('{app}.urls'.format(app=plugin))
    except ImportError as error:
        if error != ('No module named urls',):
            raise
        else:
            logger.info('App {pp} does not have a urls file', app=plugin)
    else:
        plugin_urls = url(
            r'^{plugin}/'.format(plugin=plugin),
            include(urls, namespace=plugin)
        )
        urlpatterns.append(plugin_urls)

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL,
                          document_root=settings.MEDIA_ROOT)

berou/blog/urls.py
from django.conf.urls import url
from blog import views

urlpatterns = [
    url(r'^create$', views.CreatePostView.as_view(), name='create'),
    url(r'^$', views.ListPostView.as_view(), name='list'),
    url(r'^test$', views.Test.as_view(), name='list'),

    # url(r'^$', views.ListPostView.as_view(), name='list'),
 ]

berou/berou/views.py
# -*- coding: utf-8 -*-

from django.core.urlresolvers import reverse
from django.shortcuts import redirect, render
from django.views.generic.list import ListView

from application_system import models
from berou import mixins


class ListAppView(mixins.OwnershipRequiredMixin, ListView):
    model = models.App.users.through

    def get(self, request, *args, **kwargs):
        if request.user.is_authenticated():
            super(ListAppView, self).get(request, *args, **kwargs)
            return render(
                request,
                'berou/home.html',
                self.get_context_data(**kwargs)
            )
        return redirect(reverse('berou:about'))

berou/berou/templates/berou/about.html
{% extends 'berou/base.html' %}
{% load staticfiles i18n %}
{% block content %}
<style>
section.three-columns {
    font-size: 1.5em;
}
section.three-columns div.col-md-4 {
    min-height: 450px;
}
section.two-columns {
    font-size: 1.8em;
}
section.about {
    padding: 80px 0;
}
section.about-blue {
    background-color: rgb(97, 152, 186);
}
section.about-purple {
    background-color: rgb(152, 130, 186);
}
section.about-green {
    background-color: rgb(68, 159, 100);
}
.vertical-space {
    margin-bottom: 100px;
}
a[name=user],
a[name=developer],
a[name=sysadmin],
a[name=user]:hover,
a[name=developer]:hover,
a[name=sysadmin]:hover,
a[name=user]:focus,
a[name=developer]:focus,
a[name=sysadmin]:focus {
    color: #000000 !important;
    text-decoration: none;
}
a[name=user],
a[name=developer],
a[name=sysadmin],
a[name=user]:focus,
a[name=developer]:focus,
a[name=sysadmin]:focus {
    outline: none;
    outline-offset: -2px;
}
section.about small {
    color: #1C007A;
}
section div.content {
    margin-top: 100px;
}
section a,
section a:hover,
section a:active {
    color: #1C007A;
}
</style>
<section class="about three-columns row">
    <div class="container-fluid">
        <h1 class="text-center">{% trans "The Bérou project" %}</h1>
        <img class="thumbnail center-block" alt="Bérou logo" src="{% static 'berou/img/berou.svg' %}" />
        <div class="row vertical-space">
            <div class="col-md-offset-2 col-md-8">
                Bérou is a website where you have access to a repository of applications that you can enable/disable per user account.
                It provides multiple advantages for users, developers as well as system administrators.
            </div>
        </div>
        <p>
        <div class="col-md-4">
            <h3>{% trans "For the user" %}</h3>
            <div class="container-fluid">
                <div class="row">
                    <div class="col-xs-6">
                        <img class="about-logo img-responsive" src="{% static 'berou/img/user_female.svg' %}" alt="{% trans 'User female' %}" />
                    </div>
                    <div class="col-xs-6">
                        <img class="about-logo img-responsive" src="{% static 'berou/img/user_male.svg' %}" alt="{% trans 'User male' %}" />
                    </div>
                </div>
            </div>
            <ul class="list-unstyled">
                <li>{% trans "Lots of apps ready to be used" %}</li>
                <li>{% trans "Ads free" %}</li>
                <li>{% trans "Libre software" %}</li>
            </ul>
            <a href="#user" class="pull-right btn btn-lg btn-info">{% trans "Go to User section" %}</a>
        </div>
        <div class="col-md-4">
            <h3>{% trans "For the developer" %}</h3>
            <div class="row">
                <div class="col-xs-6">
                    <img class="about-logo" src="{% static 'berou/img/developer.svg' %}" alt="{% trans 'User male' %}" />
                </div>
            </div>
            <ul class="list-unstyled">
                <li>{% trans "Development made easy" %}</li>
                <li>{% trans "Focus on your app" %}</li>
                <li>{% trans "Helpers included" %}</li>
            </li>
            <a href="#developer" class="pull-right btn btn-lg btn-info">{% trans "Go to developer section" %}</a>
        </div>
        <div class="col-md-4">
            <h3>{% trans "For the system administrator" %}</h3>
            <div class="row">
                <div class="col-xs-6">
                    <img class="about-logo" src="{% static 'berou/img/sysadmin.svg' %}" alt="{% trans 'User male' %}" />
                </div>
            </div>
            <ul class="list-unstyled">
                <li>{% trans "Ready to be deployed" %}</li>
                <li>{% trans "Comes with batteries included" %}</li>
                <li>{% trans "Just a few commands to type" %}</li>
            </ul>
            <a href="#sysadmin" class="pull-right btn btn-lg btn-info">{% trans "Go to System administrator section" %}</a>
        </div>
        </p>
    </div>
</section>

<section class="about two-columns about-blue row">
    <div class="container-fluid text-center">
        <h2 class="text-center"><a name="user">{% trans "For the user" %}</a></h2>
        <div class="col-md-6">
            <img class="thumbnail img-responsive" src="{% static 'berou/img/erika.png' %}" alt="Erika" />
            <h3 style="margin-top: 20px">{% trans "Erika: Store your links" %}</h3>
        </div>
        <div class="col-md-6">
            <div class="content">
                <ul class="list-unstyled">
                    <li>{% trans "Comes with apps pre-installed" %}</li>
                    <li>{% trans "Libre software <small>We think this matters</small>" %}</li>
                    <li>{% trans "Interface designed to be easy to use" %}</li>
                    <li>{% trans "Works on mobile" %}</li>
                    <li>{% trans "Ads free <small>We do not believe in ads</small>" %}</li>
                </ul>
                <a href="{% url 'accounts:register_user' %}" class="btn btn-lg btn-default">{% trans "Register now!" %}</a>
            </div>
        </div>
    </div>
</section>
<section class="about two-columns about-green row">
    <div class="container-fluid text-center">
        <h2 class="text-center"><a name="developer">{% trans "For the developer" %}</a></h2>
        <div class="col-md-6">
            <ul class="list-unstyled">
                <li>{% trans "Bérou is a Django project" %}</li>
                <li>{% trans "Focus on your app <small>and only your app</small>" %}</li>
                <li>{% trans "Helpers included to make development faster" %}</li>
                <li>{% trans "Use great technologies" %}</li>
                <li>{% trans "Use Django Generic Class-Based Views" %}</li>
                <a href="http://docs.berou.fr/tutorial.html" class="btn btn-lg btn-default">{% trans "Create your first app" %}</a>
            </ul>
        </div>
        <div class="col-md-6">
            <img class="img-responsive" src="{% static 'berou/img/technologies.png' %}" alt="Technologies used in Bérou" />
            <h3 style="margin-top: 20px">{% trans "Technologies used by Bérou:" %} <a href="https://www.python.org/">{% trans "Python" %}</a> / <a href="https://www.djangoproject.com/">{% trans "Django" %}</a> / <a href="http://getbootstrap.com/">{% trans "Bootstrap" %}</a></h3>
        </div>
    </div>
</section>
<section class="about two-columns about-purple row">
    <div class="container-fluid text-center">
        <h2 class="text-center"><a name="sysadmin">{% trans "For the system administrator" %}</a></h2>
        <div class="col-md-6">
            <img class="img-responsive" src="{% static 'berou/img/deployment_tools.png' %}" alt="Deployment tools used in Bérou" />
            <h3 style="margin-top: 20px">{% trans "Deployment tools used by Bérou:" %} <a href="https://www.python.org/">{% trans "nginx" %}</a> / <a href="https://www.djangoproject.com/">{% trans "gunicorn" %}</a> / <a href="http://getbootstrap.com/">{% trans "supervisor" %}</a></h3>
        </div>
        <div class="col-md-6">
            <div class="content">
                <h3>{% trans "Comes with deployment tools pre-configured" %}</h3>
                <h3>{% trans "You just need to adjust a few paths" %}</h3>
                <h3>{% trans "Ansible is planned to be used to simplify even more the process" %}</h3>
                <h3>{% trans "Manage the apps you want to install with" %} <a href="https://en.wikipedia.org/wiki/Pip_%28package_manager%29">{% trans "pip" %}</a></h3>
                <a href="http://docs.berou.fr/" class="btn btn-lg btn-default">{% trans "Install Bérou on your own server" %}</a>
            </div>
        </div>
    </div>
</section>
{% endblock content %}

berou/berou/templates/berou/banner.html
{% load banner i18n %}
<ul class="nav navbar-nav">
    {% for app in list_app %}
        {% if request.path|path_startswith:app.package %}
        <li class="active"><a href="/{{ app.package }}">{% trans app.name %}<span class="sr-only">{% trans "(current)" %}</span></a></li>
        {% else %}
        <li><a href="/{{ app.package }}">{% trans app.name %}</a></li>
        {% endif %}
    {% endfor %}
</ul>

berou/berou/templates/berou/base.html
{% load staticfiles form_helpers banner i18n %}
<!DOCTYPE html>
<html>
<head>
<link rel="stylesheet" href="{% static 'bootstrap-3.3.4/css/bootstrap.css' %}">
<script src="{% static 'jquery-1.11.2/js/jquery.min.js' %}"></script>
<script src="{% static 'bootstrap-3.3.4/js/bootstrap.js' %}"></script>
<link rel="shortcut icon" type="image/x-pngicon" href="{% static 'berou/img/favicon.png' %}"/>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<title>Bérou</title>
</head>
<body>
<div id="wrap">
    <nav class="navbar navbar-default">
        <div class="container-fluid">
            <!-- Brand and toggle get grouped for better mobile display -->
            <div class="navbar-header">
                <a class="navbar-brand" href="{% url 'berou:home' %}"><img class="logo" alt="Bérou" src="{% static 'berou/img/berou.svg' %}"></a>
            </div>

            {% if user.is_authenticated %}
            <div class="navbar-collapse">
                {% banner request user %}
                <ul class="nav navbar-nav navbar-right">
                    <li class="dropdown">
                    <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false">{{ user }} <span class="caret"></span></a>
                    <ul class="dropdown-menu" role="menu">
                        <li><a href="{% url 'accounts:profile' pk=user.id %}">{% trans "Profile" %}</a></li>
                        <li><a href="{% url 'application_system:manage_my_apps' %}">{% trans "Manage my apps" %}</a></li>
                        <li role="presentation" class="divider"></li>
                        <li><a href="{% url 'accounts:logout_user' %}">{% trans "Logout" %}</a></li>
                        <li role="presentation" class="divider"></li>
                        <li><a href="{% url 'berou:about' %}">{% trans "About Bérou" %}</a></li>
                    </ul>
                    </li>
                </ul>
            </div><!-- /.navbar-collapse -->
            {% else %}
            <!-- TODO: use the actual login form -->
            <div class="navbar-form navbar-right">
                <form action="{% url 'accounts:login_user' %}?next={{ request.path }}" method="POST" class="form-inline">
                    {% csrf_token %}
                    {{ login_form.username|add_class:"form-control" }}
                    {{ login_form.password|add_class:"form-control" }}
                    <button type="submit" class="btn btn-default">Login</button>
                </form>
            </div>
            {% endif %}
        </div><!-- /.container-fluid -->
    </nav>
    <div class="container-fluid">
        <div class="row">
            {% for message in messages %}
            {% if message.level == DEFAULT_MESSAGE_LEVELS.ERROR %}
            <div class="alert alert-error" role="alert">{{ message }}</div>
            {% elif message.level == DEFAULT_MESSAGE_LEVELS.INFO %}
            <div class="alert alert-info" role="alert">{{ message }}</div>
            {% endif %}
            {% endfor %}
        </div>
        {% block content %}
        {% endblock content %}
    </div>
</div>
<footer id="footer" class="footer">
    <div class="container">
        <div class="row">
            <div class="col-md-6">
                <h3>Bérou</h3>
                <ul>
                    <li><a href="/">{% trans "Home" %}</a></li>
                    <li><a href="{% url 'application_system:manage_my_apps' %}">{% trans "Manage my apps" %}</a></li>
                    <li><a href="{% url 'berou:about' %}">{% trans "About Bérou" %}</a></li>
                    <li><a href="{% url 'accounts:logout_user' %}">{% trans "Logout" %}</a></li>
                </ul>
            </div>
            <div class="col-md-6">
                <h3>{% trans "Development" %}</h3>
                <ul>
                    <li><a href="http://docs.berou.fr/">{% trans "Documentation" %}</a></li>
                    <li><a href="https://gitlab.com/Pacodastre/Berou">{% trans "Gitlab" %}</a></li>
                    <li><a href="http://pypi.berou.fr/simple/">{% trans "Apps repository" %}</a></li>
                </ul>
            </div>
        </div>
    </div>
</footer>
</body>
</html>

berou/berou/templates/berou/home.html
{% extends 'berou/base.html' %}
{% load staticfiles i18n partition %}
{% block content %}
<div class="row">
    <div class="col-md-12 page-header">
        <h1>
            {% trans "My apps" %}
            <a href="{% url 'application_system:manage_my_apps' %}" class="btn btn-default">
                {% trans "Manage my apps" %}
            </a>
        </h1>
    </div>
</div>
{% if object_list %}
{% for row_apps in object_list|partition:"3" %}
<div class="row">
    {% for user_app in row_apps %}
    {% with app=user_app.app %}
    <div class="col-md-4">
        <a href="/{{ app.package }}/">
            <div class="media">
                <div class="media-left">
                {% if app.logo %}
                    <img class="img-thumbnail media-object logo" src="{{ app.logo }}" alt="{{ app.name }}" />
                {% else %}
                    <img class="img-thumbnail media-object logo" src="{% static 'application_system/img/no_logo.svg' %}" alt="{{ app.name }}" />
                {% endif %}
                </div>
                <div class="media-body">
                    <h4 class="media-heading">{% trans app.name %}</h4>
                    {% trans app.description %}
                    <div class="text-right">
                        <button class="btn btn-info">{% blocktrans with name=app.name %}Go to {{ name }}{% endblocktrans %}</button>
                    </div>
                </div>
            </div>
        </a>
    </div>
    {% endwith %}
    {% endfor %}
</div>
{% endfor %}
{% else %}
{% trans "You don't have any enabled apps." %} <a href="{% url 'application_system:manage_my_apps' %}" class="btn btn-primary">{% trans "Activate your apps" %}</a>
{% endif %}
{% endblock content %}